# Class VulkanCopyDescriptorSet.Builder

java.lang.Object
com.io7m.jcoronado.api.VulkanCopyDescriptorSet.Builder

Enclosing class:
  `VulkanCopyDescriptorSet`

public static final class VulkanCopyDescriptorSet.Builder extends Object
Builds instances of type `VulkanCopyDescriptorSet`. Initialize attributes and then invoke the `build()` method to create an immutable instance.

`Builder` is not thread-safe and generally should not be stored in a field or collection, but instead used immediately to create instances.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `VulkanCopyDescriptorSet`
  `build()`
  Builds a new `VulkanCopyDescriptorSet`.
  `final VulkanCopyDescriptorSet.Builder`
  `from(VulkanCopyDescriptorSetType instance)`
  Fill a builder with attribute values from the provided `VulkanCopyDescriptorSetType` instance.
  `final VulkanCopyDescriptorSet.Builder`
  `setDescriptorCount(int descriptorCount)`
  Initializes the value for the `descriptorCount` attribute.
  `final VulkanCopyDescriptorSet.Builder`
  `setDestinationArrayElement(int destinationArrayElement)`
  Initializes the value for the `destinationArrayElement` attribute.
  `final VulkanCopyDescriptorSet.Builder`
  `setDestinationBinding(int destinationBinding)`
  Initializes the value for the `destinationBinding` attribute.
  `final VulkanCopyDescriptorSet.Builder`
  `setDestinationSet(VulkanDescriptorSetType destinationSet)`
  Initializes the value for the `destinationSet` attribute.
  `final VulkanCopyDescriptorSet.Builder`
  `setSourceArrayElement(int sourceArrayElement)`
  Initializes the value for the `sourceArrayElement` attribute.
  `final VulkanCopyDescriptorSet.Builder`
  `setSourceBinding(int sourceBinding)`
  Initializes the value for the `sourceBinding` attribute.
  `final VulkanCopyDescriptorSet.Builder`
  `setSourceSet(VulkanDescriptorSetType sourceSet)`
  Initializes the value for the `sourceSet` attribute.

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Method Details

  - ### from

    public final VulkanCopyDescriptorSet.Builder from(VulkanCopyDescriptorSetType instance)
    Fill a builder with attribute values from the provided `VulkanCopyDescriptorSetType` instance. Regular attribute values will be replaced with those from the given instance. Absent optional values will not replace present values.
    Parameters:
      `instance` - The instance from which to copy values
    Returns:
      `this` builder for use in a chained invocation

  - ### setSourceSet

    public final VulkanCopyDescriptorSet.Builder setSourceSet(VulkanDescriptorSetType sourceSet)
    Initializes the value for the `sourceSet` attribute.
    Parameters:
      `sourceSet` - The value for sourceSet
    Returns:
      `this` builder for use in a chained invocation

  - ### setSourceBinding

    public final VulkanCopyDescriptorSet.Builder setSourceBinding(int sourceBinding)
    Initializes the value for the `sourceBinding` attribute.
    Parameters:
      `sourceBinding` - The value for sourceBinding
    Returns:
      `this` builder for use in a chained invocation

  - ### setSourceArrayElement

    public final VulkanCopyDescriptorSet.Builder setSourceArrayElement(int sourceArrayElement)
    Initializes the value for the `sourceArrayElement` attribute.
    Parameters:
      `sourceArrayElement` - The value for sourceArrayElement
    Returns:
      `this` builder for use in a chained invocation

  - ### setDestinationSet

    public final VulkanCopyDescriptorSet.Builder setDestinationSet(VulkanDescriptorSetType destinationSet)
    Initializes the value for the `destinationSet` attribute.
    Parameters:
      `destinationSet` - The value for destinationSet
    Returns:
      `this` builder for use in a chained invocation

  - ### setDestinationBinding

    public final VulkanCopyDescriptorSet.Builder setDestinationBinding(int destinationBinding)
    Initializes the value for the `destinationBinding` attribute.
    Parameters:
      `destinationBinding` - The value for destinationBinding
    Returns:
      `this` builder for use in a chained invocation

  - ### setDestinationArrayElement

    public final VulkanCopyDescriptorSet.Builder setDestinationArrayElement(int destinationArrayElement)
    Initializes the value for the `destinationArrayElement` attribute.
    Parameters:
      `destinationArrayElement` - The value for destinationArrayElement
    Returns:
      `this` builder for use in a chained invocation

  - ### setDescriptorCount

    public final VulkanCopyDescriptorSet.Builder setDescriptorCount(int descriptorCount)
    Initializes the value for the `descriptorCount` attribute.
    Parameters:
      `descriptorCount` - The value for descriptorCount
    Returns:
      `this` builder for use in a chained invocation

  - ### build

    public VulkanCopyDescriptorSet build()
    Builds a new `VulkanCopyDescriptorSet`.
    Returns:
      An immutable instance of VulkanCopyDescriptorSet
    Throws:
      `IllegalStateException` - if any required attributes are missing